/*************************************************************************************************************
File: Main_Board.ino

Firmware Developed by: 
Ph.D. Eng. Rodrigo H. Gounella (rodrigogounella@usp.br)

Firmware Updated:
Ph.D. Eng. Rodrigo H. Gounella (rodrigogounella@usp.br)

--------------------------------------------------------------
Members:
Advisors: Ph.D. João Paulo Carmo (jcarmo@sc.usp.br) and Ph.D. Ben-Hur Viana Borges (benhur@sc.usp.br) 
Hardware: Ph.D. Eng. Rodrigo H. Gounella (rodrigogounella@usp.br)
Software: Ph.D. Eng. Rodrigo H. Gounella (rodrigogounella@usp.br)

Note: Code developed to an Arduino Mega
*************************************************************************************************************/
 
 #include <SoftwareSerial.h>
 #include <SPI.h>        
 #include <SD.h>

 #define SD_pin  53
     
 #define dir_1_Pin 2
 #define step_1_Pin 3
 #define dir_2_Pin 4
 #define step_2_Pin 5
 
 #define lsw_1 27
 #define lsw_2 31
 #define lsw_3 29
 #define lsw_4 25

 #define control 23

 #define Supply_BT 13

 SoftwareSerial Bluetooth(12, 11); // Arduino(RX, TX) - HC-05 Bluetooth (TX, RX)

 unsigned int stepsPercicle = 1;
 unsigned int n_measurements = 20;
 unsigned int t_pulse = 500;
 unsigned int velocity = 1;
 const float ioref = 5.0200;
 const float n_bits = 1023.0000;
 float amp = 0.0;
 unsigned int numA = 1;
 unsigned int numB = 1;
 unsigned int numC = 1;
 unsigned int numD = 1;
 unsigned int numE = 1;
 int numF = 1;
 int numH = 1;
 float numI = 0.0;
 unsigned int numJ = 0;
 unsigned int numK = 0;
 String dataIn = "";
 String dataInN = "";
 String dataInS= "";
 int Mode = 0; //Measurement Mode
 unsigned int intensity[1350];
 unsigned long x = 0;
 
 File logFile;
 
 void(* resetFunc) (void) = 0;  
  
 void setup() {
     pinMode(Supply_BT, OUTPUT);
     digitalWrite(Supply_BT, HIGH);
     
     delay(100);
     pinMode(control, OUTPUT);
     digitalWrite(control, LOW);

     pinMode(lsw_1, INPUT);
     pinMode(lsw_2, INPUT);
     pinMode(lsw_3, INPUT);
     pinMode(lsw_4, INPUT);

     pinMode(step_1_Pin, OUTPUT);
     pinMode(dir_1_Pin, OUTPUT);
     pinMode(step_2_Pin, OUTPUT);
     pinMode(dir_2_Pin, OUTPUT);
     
     pinMode(SD_pin, OUTPUT);
     pinMode(A2, INPUT);
     
     Serial.begin(9600);
     Bluetooth.begin(9600);
     Bluetooth.setTimeout(10);
     delay(50);

      while (!digitalRead(lsw_1)) {
       // do nothing
       // wait serial or command
      }
     delay(50);
     
     Bluetooth.println("Press Button Start");
      while (Bluetooth.read() != 'A') {
       // do nothing
       // wait Bluetooth command 
       if (Bluetooth.read() == 'C') resetFunc();
      }
     delay(50);
     
      digitalWrite(dir_1_Pin, HIGH);
      delay(50);
      while (!digitalRead(lsw_3)){  
       digitalWrite(step_1_Pin, HIGH);
       delayMicroseconds(500);
       digitalWrite(step_1_Pin, LOW);
       delayMicroseconds(500);
       //---------------------------------------------
          if (Bluetooth.read() == 'B') {
           while (Bluetooth.read() != 'A') {
          // do nothing
          // wait Bluetooth command 
          if (Bluetooth.read() == 'C') resetFunc();
          }   
         }
       //---------------------------------------------
      }
      delay(50);
      
      digitalWrite(dir_2_Pin, HIGH); 
      delay(50);
      while (!digitalRead(lsw_4)){
       digitalWrite(step_2_Pin, HIGH);
       delayMicroseconds(500);
       digitalWrite(step_2_Pin, LOW);
       delayMicroseconds(500); 
       //---------------------------------------------
          if (Bluetooth.read() == 'B') {
           while (Bluetooth.read() != 'A') {
          // do nothing
          // wait Bluetooth command 
          if (Bluetooth.read() == 'C') resetFunc();
          }   
         }
       //---------------------------------------------   
      }
      delay(50);
      
      digitalWrite(dir_1_Pin, LOW);
      delay(50);
      while (!digitalRead(lsw_1)){        
       digitalWrite(step_1_Pin, HIGH);
       delayMicroseconds(500);
       digitalWrite(step_1_Pin, LOW);
       delayMicroseconds(500);
       numD++;
       //---------------------------------------------
          if (Bluetooth.read() == 'B') {
           while (Bluetooth.read() != 'A') {
          // do nothing
          // wait Bluetooth command
          if (Bluetooth.read() == 'C') resetFunc();
          }   
         }
       //---------------------------------------------
      }
      delay(50);
        
      digitalWrite(dir_1_Pin, HIGH);
      delay(50);
       for(int i = 1; i <= (numD/2); i++){   
        digitalWrite(step_1_Pin, HIGH);
        delayMicroseconds(500);
        digitalWrite(step_1_Pin, LOW);
        delayMicroseconds(500);
       //---------------------------------------------
          if (Bluetooth.read() == 'B') {
           while (Bluetooth.read() != 'A') {
          // do nothing
          // wait Bluetooth command
          if (Bluetooth.read() == 'C') resetFunc();
          }   
         }
       //---------------------------------------------
       }
       delay(50);

       digitalWrite(dir_2_Pin, LOW);
       delay(50);
       while (!digitalRead(lsw_2)){       
        digitalWrite(step_2_Pin, HIGH);
        delayMicroseconds(500);
        digitalWrite(step_2_Pin, LOW);
        delayMicroseconds(500);
        numE++;
       //---------------------------------------------
          if (Bluetooth.read() == 'B') {
           while (Bluetooth.read() != 'A') {
          // do nothing
          // wait Bluetooth command 
          if (Bluetooth.read() == 'C') resetFunc();
          }   
         }
       //---------------------------------------------
       }
       delay(50);
       
        digitalWrite(dir_2_Pin, HIGH);
        delay(50);
        for(int i = 1; i <= (numE/2); i++){       
         digitalWrite(step_2_Pin, HIGH);
         delayMicroseconds(500);
         digitalWrite(step_2_Pin, LOW);
         delayMicroseconds(500);
       //---------------------------------------------
          if (Bluetooth.read() == 'B') {
           while (Bluetooth.read() != 'A') {
          // do nothing
          // wait Bluetooth command 
          if (Bluetooth.read() == 'C') resetFunc();
          }   
         }
       //---------------------------------------------
        } 
       delay(50);

       Bluetooth.println("Adjust Amplifier and Press Button Start Again");
       delay(3000);
       while (Bluetooth.read() != 'A') {
        for (int i = 1; i <= 100; i++) {
         amp = amp + analogRead(A2);
         if (Bluetooth.read() == 'A') break;
         }
        amp = amp/100;
        amp = amp*ioref/n_bits;
        Bluetooth.print("Signal Power: ");
        Bluetooth.print(amp, 4);
        Bluetooth.println();
       }
      delay(50);
      
      if (!SD.begin(SD_pin)) {
       Bluetooth.println("SD Card Failed. Fix the problem and Press STOP Button to Reset");
       delay(20);
        while (Bluetooth.read() != 'C') {
         // do nothing
         // wait a command
       }
       resetFunc();
      } 
       else {
        Bluetooth.println("SD Card OK");
      }
          
     char filename[] = "file0000.csv";

     Bluetooth.println("Reading old files");
      do {
       sprintf(filename,"file%04d.csv", numC); 
       logFile = SD.open(filename, FILE_READ);
       delay(10);
       logFile.close();
       numC++;
      } while (SD.exists(filename)); 
 
     Bluetooth.println("Removing old files");
      do {
       sprintf(filename,"file%04d.csv", numB); 
       SD.remove(filename);
       numB++;
      } while (numB <= numC);  
       if (SD.exists(filename)){
        Bluetooth.println("Could not delete all data");
       }
       else {
        Bluetooth.println("All files deleted");   
       }

     Bluetooth.println("Select Measurement Mode");
       while(dataInS != "1" && dataInS != "2" && dataInS != "3" && dataInS != "Q") { 
       // do nothing
       // wait Bluetooth command
        dataIn = Bluetooth.readStringUntil('\n');
        dataInS = dataIn.substring(0, 1);
       }
        
        if (dataInS == "1") Mode = 1; //Distance Mode
        if (dataInS == "2") Mode = 2; //Angle Mode
        if (dataInS == "3") Mode = 3; //Both Distance and Angle Mode   
        if (dataInS == "Q") Mode = 4; //Free Movement Mode  
        
       delay(50);
       if (Mode == 1) Bluetooth.println("The Selected Mode is Distance");
       if (Mode == 2) Bluetooth.println("The Selected Mode is Angle");
       if (Mode == 3) Bluetooth.println("The Selected Mode is Both");
       if (Mode == 4) Bluetooth.println("The Selected Mode is Free Movement");
       delay(3000);
       dataIn = "";
       dataInS = "";
       dataInN = "";
       delay(50);
       
     if (Mode == 1 || Mode == 2 || Mode == 3) {       
      delay(50);    
      Bluetooth.println("Adjust Resolution");
       delay(50);
       while (dataInS != "D") {
         // do nothing
         // wait a command
         dataIn = Bluetooth.readStringUntil('\n');
         dataInS = dataIn.substring(0, 1);
         dataInN = dataIn.substring(1, dataIn.length());
         stepsPercicle = dataInN.toInt();
       }
       dataIn = "";
       dataInS = "";
       dataInN = "";
        
        delay(50);
         
if(stepsPercicle == 1) t_pulse = 1000;
if(stepsPercicle == 2) t_pulse = 700;


      delay(50);    
      Bluetooth.println("Adjust Accuracy");
       delay(50);
       while (dataInS != "E") {
         // do nothing
         // wait a command
         dataIn = Bluetooth.readStringUntil('\n');
         dataInS = dataIn.substring(0, 1);
         dataInN = dataIn.substring(1, dataIn.length());
         n_measurements = dataInN.toInt();
       }
       dataIn = "";
       dataInS = "";
       dataInN = "";
        
        delay(50);   
        digitalWrite(dir_1_Pin, HIGH);
         while (!digitalRead(lsw_3)){      
          digitalWrite(step_1_Pin, HIGH);
          delayMicroseconds(500);
          digitalWrite(step_1_Pin, LOW);
          delayMicroseconds(500);
          //---------------------------------------------
            if (Bluetooth.read() == 'B') {
             while (Bluetooth.read() != 'A') {
             // do nothing
             // wait Bluetooth command 
             if (Bluetooth.read() == 'C') resetFunc();
             }   
            }
          //---------------------------------------------  
         }
         digitalWrite(dir_2_Pin, HIGH);
           while (!digitalRead(lsw_4)){        
            digitalWrite(step_2_Pin, HIGH);
            delayMicroseconds(500);
            digitalWrite(step_2_Pin, LOW);
            delayMicroseconds(500); 
             //---------------------------------------------
               if (Bluetooth.read() == 'B') {
                while (Bluetooth.read() != 'A') {
                // do nothing
                // wait Bluetooth command 
                if (Bluetooth.read() == 'C') resetFunc();
                }   
               }
             //---------------------------------------------
           }

          numD = numD/stepsPercicle;
          numE = numE/stepsPercicle;
          numI = 20/stepsPercicle;
          numI = 2*(round(numI));
          numD = numD - numI;
          numE = numE - numI; 
          //Bluetooth.println(String(numD) +" "+ String(numE) +" "+ String(numI));
                   
          Bluetooth.println("Setting Z axis");
          delay(100);
     }
              
      if (Mode == 4){
        numD = numD/2;
        numE = numE/2;  
      }
      
     digitalWrite(control, HIGH);
     delay(100);
     digitalWrite(control, LOW);
     delay(100);

}
           
void loop() {

    if (Mode == 1 || Mode == 2 || Mode == 3) {
      
     char filename[] = "file0000.csv";
     sprintf(filename,"file%04d.csv",numA);  
      
      pinMode(control, INPUT);
      delay(1000);
      do {
       //do nothing
       //wait a command
       if (Bluetooth.read() == 'C') resetFunc();
      } while (!digitalRead(control));

       delay(200);
       pinMode(control, OUTPUT);
       digitalWrite(control,LOW); 
       Bluetooth.println("Number of Measurements: " + String(numA));

       delay(100);
       digitalWrite(dir_1_Pin, LOW);
       while (numJ < numI) {
        for(int i = 0; i < stepsPercicle; i++){
              digitalWrite(step_1_Pin, HIGH);
              delayMicroseconds(t_pulse);
              digitalWrite(step_1_Pin, LOW);
              delayMicroseconds(t_pulse);
             //---------------------------------------------
               if (Bluetooth.read() == 'B') {
                while (Bluetooth.read() != 'A') {
                // do nothing
                // wait Bluetooth command 
                if (Bluetooth.read() == 'C') resetFunc();
                }   
               }
                if (digitalRead(lsw_1)) break;
             //---------------------------------------------
             }
            numJ++;   
       }
        delay(100);
         while (numK < numI) {
          digitalWrite(dir_2_Pin, LOW);
           for(int i = 0; i < stepsPercicle; i++){
            digitalWrite(step_2_Pin, HIGH);
            delayMicroseconds(t_pulse);
            digitalWrite(step_2_Pin, LOW);
            delayMicroseconds(t_pulse);
            //---------------------------------------------
              if (Bluetooth.read() == 'B') {
               while (Bluetooth.read() != 'A') {
               // do nothing
               // wait Bluetooth command 
               if (Bluetooth.read() == 'C') resetFunc();
               }   
              }
               if (digitalRead(lsw_2)) break;
            //---------------------------------------------
           }
          numK++;
         }

         delay(1000);
         
        do {
           
         numF = 1; 
         numH = 1;
         
         digitalWrite(dir_1_Pin, LOW);
          while ((numJ < numD) && !digitalRead(lsw_1)){
           x = 0;
            for(int i = 0; i < n_measurements ; i++){
             x = analogRead(A2) + x;      
            }
            x = round(x/n_measurements);
            intensity[numF] = x;
            numF++;
            
             for(int i = 0; i < stepsPercicle; i++){
              digitalWrite(step_1_Pin, HIGH);
              delayMicroseconds(t_pulse);
              digitalWrite(step_1_Pin, LOW);
              delayMicroseconds(t_pulse);
             //---------------------------------------------
               if (Bluetooth.read() == 'B') {
                while (Bluetooth.read() != 'A') {
                // do nothing
                // wait Bluetooth command 
                if (Bluetooth.read() == 'C') resetFunc();
                }   
               }
                if (digitalRead(lsw_1)) break;
             //---------------------------------------------
             }
            numJ++;    
          }
         //Bluetooth.println(String(numF));
           
          digitalWrite(dir_2_Pin, LOW);
           for(int i = 0; i < stepsPercicle; i++){
            digitalWrite(step_2_Pin, HIGH);
            delayMicroseconds(t_pulse);
            digitalWrite(step_2_Pin, LOW);
            delayMicroseconds(t_pulse);
            //---------------------------------------------
              if (Bluetooth.read() == 'B') {
               while (Bluetooth.read() != 'A') {
               // do nothing
               // wait Bluetooth command 
               if (Bluetooth.read() == 'C') resetFunc();
               }   
              }
               if (digitalRead(lsw_2)) break;
            //---------------------------------------------
           }
           
             logFile = SD.open(filename, FILE_WRITE);
              if (logFile) {
                for (int j = numH; j < numF; j++) {
                 logFile.print(intensity[j]);
                 logFile.print(";");	
                }
                logFile.println();
                logFile.close();
               }              
               else {
                Bluetooth.println("Storage file access error. Press Buttom Stop to Reset");
                delay(20);
                 while (Bluetooth.read() != 'C') {
                  // do nothing
                  // wait a command
                 }
                 resetFunc();
               } 
            
            numK++;        
            
            numH = numF-1;
            digitalWrite(dir_1_Pin, HIGH);   
             while (numJ > numI && !digitalRead(lsw_3)){
              x = 0;
               for(int i = 0; i < n_measurements ; i++){
                x = analogRead(A2) + x;      
                }
                x = round(x/n_measurements);
                intensity[numH] = x;
                numH--;
                
                 for(int i = 0; i < stepsPercicle; i++){  
                  digitalWrite(step_1_Pin, HIGH);
                  delayMicroseconds(t_pulse);
                  digitalWrite(step_1_Pin, LOW);
                  delayMicroseconds(t_pulse);
                  //---------------------------------------------
                   if (Bluetooth.read() == 'B') {
                    while (Bluetooth.read() != 'A') {
                    // do nothing
                    // wait Bluetooth command 
                    if (Bluetooth.read() == 'C') resetFunc();
                    }   
                   }
                    if (digitalRead(lsw_3)) break;
                  //---------------------------------------------
                 }
                numJ--;
             }
             //Bluetooth.println(String(numH));
                
             digitalWrite(dir_2_Pin, LOW);
              for(int i = 0; i < stepsPercicle; i++){
               digitalWrite(step_2_Pin, HIGH);
               delayMicroseconds(t_pulse);
               digitalWrite(step_2_Pin, LOW);
               delayMicroseconds(t_pulse);
               //---------------------------------------------
                if (Bluetooth.read() == 'B') {
                 while (Bluetooth.read() != 'A') {
                  // do nothing
                  // wait Bluetooth command 
                 if (Bluetooth.read() == 'C') resetFunc();
                 }   
                }
                 if (digitalRead(lsw_2)) break;
               //---------------------------------------------
              }
              
                logFile = SD.open(filename, FILE_WRITE);
                 if (logFile) {
                   for (int j = numH+1; j < numF; j++) {
                    logFile.print(intensity[j]);
                    logFile.print(";");
                   }
                   logFile.println();
                   logFile.close();
                  } 
                  else {
                   Serial.println("Storage file access error. Press Buttom Stop to Reset");
                   delay(20);
                    while (Bluetooth.read() != 'C') {
                     // do nothing
                     // wait a command
                    }
                    resetFunc();
                  }

               numK++;
            
        } while ((numK < numE) && !digitalRead(lsw_2));

       numA++;
         
            digitalWrite(dir_1_Pin, HIGH);
             while (!digitalRead(lsw_3)){  
              digitalWrite(step_1_Pin, HIGH);
              delayMicroseconds(500);
              digitalWrite(step_1_Pin, LOW);
              delayMicroseconds(500);
             //---------------------------------------------
              if (Bluetooth.read() == 'B') {
               while (Bluetooth.read() != 'A') {
                // do nothing
                // wait Bluetooth command 
               if (Bluetooth.read() == 'C') resetFunc();
               }   
              }
             //---------------------------------------------
             }

             digitalWrite(dir_2_Pin, HIGH);
              while (!digitalRead(lsw_4)){
               digitalWrite(step_2_Pin, HIGH);
               delayMicroseconds(500);
               digitalWrite(step_2_Pin, LOW);
               delayMicroseconds(500);  
               //---------------------------------------------
                if (Bluetooth.read() == 'B') {
                 while (Bluetooth.read() != 'A') {
                  // do nothing
                  // wait Bluetooth command 
                  if (Bluetooth.read() == 'C') resetFunc();
                 }   
                }
               //---------------------------------------------
              }
              
              numJ = 0;
              numK = 0;
                             
              digitalWrite(control, HIGH);
              delay(100);
              digitalWrite(control, LOW);
              delay(100);
    }

    if (Mode == 4) {
      
     if (Bluetooth.read() == 'C') resetFunc();

     dataIn = Bluetooth.readStringUntil('\n');
     dataInS = dataIn.substring(0, 1);
     dataInN = dataIn.substring(1, dataIn.length());
     //Bluetooth.println(String(velocity));
     if (dataInS == "v") velocity = dataInN.toInt();
     
     Bluetooth.println("X = " + String(numD) + "    " + "Y = " + String(numE));

      if (Bluetooth.read() == 'a') {
       while (Bluetooth.read() != 'b'){
        for (int i = 1; i <= 100; i++) {
         amp = amp + analogRead(A2);
         if (Bluetooth.read() == 'b') break;
         }
        amp = amp/100;
        amp = amp*ioref/n_bits;
        Bluetooth.print("Signal Power: ");
        Bluetooth.print(amp, 4);
        Bluetooth.println();
       }
      }

     if (dataInS == "S" && !digitalRead(lsw_4)) {
      for(int i = 0; i < velocity; i++){
       digitalWrite(dir_2_Pin, HIGH);
       digitalWrite(step_2_Pin, HIGH);
       delayMicroseconds(500);
       digitalWrite(step_2_Pin, LOW);
       delayMicroseconds(500);  
       dataIn = "";
       dataInS = "";
       dataInN = "";
       if (digitalRead(lsw_4)) break;
       numE--;
      }
     }
     if (dataInS == "T" && !digitalRead(lsw_2)) {
      for(int i = 0; i < velocity; i++){
       digitalWrite(dir_2_Pin, LOW);
       digitalWrite(step_2_Pin, HIGH);
       delayMicroseconds(500);
       digitalWrite(step_2_Pin, LOW);
       delayMicroseconds(500);
       dataIn = "";
       dataInS = "";
       dataInN = "";
       if (digitalRead(lsw_2)) break;
       numE++;
      }
     }
     if (dataInS == "U" && !digitalRead(lsw_3)) {
      for(int i = 0; i < velocity; i++){
       digitalWrite(dir_1_Pin, HIGH);
       digitalWrite(step_1_Pin, HIGH);
       delayMicroseconds(500);
       digitalWrite(step_1_Pin, LOW);
       delayMicroseconds(500);  
       dataIn = "";
       dataInS = "";
       dataInN = "";
       if (digitalRead(lsw_3)) break;
       numD-- ;
      }
     }
     if (dataInS == "V" && !digitalRead(lsw_1)) {
      for(int i = 0; i < velocity; i++){
      digitalWrite(dir_1_Pin, LOW);
      digitalWrite(step_1_Pin, HIGH);
      delayMicroseconds(500);
      digitalWrite(step_1_Pin, LOW);
      delayMicroseconds(500);  
      dataIn = "";
      dataInS = "";
      dataInN = "";
      if (digitalRead(lsw_1)) break;
      numD++;
     }
    }
    if (Bluetooth.read() == 'C') resetFunc(); 
   }
 }   
