/*************************************************************************************************************
File: Secondary_Angle_Board.ino

Firmware Developed by: 
Ph.D. Eng. Rodrigo H. Gounella (rodrigogounella@usp.br)

Firmware Updated:
Ph.D. Eng. Rodrigo H. Gounella (rodrigogounella@usp.br)

--------------------------------------------------------------
Members:
Advisors: Ph.D. João Paulo Carmo (jcarmo@sc.usp.br) and Ph.D. Ben-Hur Viana Borges (benhur@sc.usp.br) 
Hardware: Ph.D. Eng. Rodrigo H. Gounella (rodrigogounella@usp.br)
Software: Ph.D. Eng. Rodrigo H. Gounella (rodrigogounella@usp.br)

Note: Code developed to an Arduino Uno 
*************************************************************************************************************/

 #include <SoftwareSerial.h>

 #define dir_Pin 12
 #define step_Pin 11
 #define dir_Pin_2 6
 #define step_Pin_2 7
 
 #define lsw_1 10
 #define lsw_2 9
 #define lsw_3 8
 
 #define control 13

 SoftwareSerial Bluetooth(3, 2); // Arduino(RX, TX) - HC-05 Bluetooth (TX, RX)
 
 int steps1mm = 158; //1 milimeter

 int IniAngle = 0; 
 int IniAngleABS = 0;
 int FinAngle = 25; 
 int AngleCounter = 0;
 int AngleStep = 1;
  
 int stoppedDis = 90; //Stopped Distance
 int distance = 90; //Create distance variable 
 int DisStep_BT = 5;
 int DisStep = 5;

 int Mode = 0; //Measurement Mode
 char lock = 1;
 
 String dataIn = "";
 String dataInN = "";
 String dataInS = "";

 void(* resetFunc) (void) = 0;  
 
  void setup() {

   Serial.begin(9600);
   Bluetooth.begin(9600);
   Bluetooth.setTimeout(10);   
   delay(300);
   
     while(dataInS != "F" && dataInS != "G" && dataInS != "H" && dataInS != "R") { 
       // do nothing
       // wait Bluetooth command
        dataIn = Bluetooth.readStringUntil('\n');
        dataInS = dataIn.substring(0, 1);
       }
               
      if (dataInS == "F") Mode = 1; //Distance Mode
      if (dataInS == "G") Mode = 2; //Angle Mode
      if (dataInS == "H") Mode = 3; //Both Distance and Angle Mode   
      if (dataInS == "R") Mode = 4; //Free Movement Mode  
      
      delay(50);
      if (Mode == 1) Bluetooth.println("The Selected Mode is Distance");
      if (Mode == 2) Bluetooth.println("The Selected Mode is Angle");
      if (Mode == 3) Bluetooth.println("The Selected Mode is Both");
      if (Mode == 4) Bluetooth.println("The Selected Mode is Free Movement");
      delay(200);
      
      dataIn = "";
      dataInS = "";
      dataInN = "";
   
   pinMode(control, INPUT); 
    do {
     //do nothing
     //wait a command     
     if (Bluetooth.read() == 'P') resetFunc();    
    } while (!digitalRead(control));

    if (Mode == 1 || Mode == 2 || Mode == 3) {
     delay(200);
     pinMode(control, OUTPUT);
     digitalWrite(control, LOW);
    }
    
    pinMode(step_Pin, OUTPUT);
    pinMode(dir_Pin, OUTPUT);
    pinMode(step_Pin_2, OUTPUT);
    pinMode(dir_Pin_2, OUTPUT);
    pinMode(lsw_1, INPUT);
    pinMode(lsw_2, INPUT); 
    pinMode(lsw_3, INPUT);
     
   //Make Angle Correction*************************************
    digitalWrite(dir_Pin_2, LOW); 
    for (int i = 1 ; i <= 15 ; i++) {
     digitalWrite(step_Pin_2, HIGH);
     delay(20);
     digitalWrite(step_Pin_2, LOW);
     delay(20);
     //---------------------------------------------
      if (Bluetooth.read() == 'O') {
       while (Bluetooth.read() != 'N') {
       // do nothing
       // wait Bluetooth command 
       if (Bluetooth.read() == 'P') resetFunc();
       }   
      }
     //---------------------------------------------  
    }
    delay(500);
    digitalWrite(dir_Pin_2, HIGH); 
     while (!digitalRead(lsw_3)){
      digitalWrite(step_Pin_2, HIGH);
      delay(20);
      digitalWrite(step_Pin_2, LOW);
      delay(20); 
      //---------------------------------------------
       if (Bluetooth.read() == 'O') {
        while (Bluetooth.read() != 'N') {
        // do nothing
        // wait Bluetooth command 
        if (Bluetooth.read() == 'P') resetFunc();
        }   
       }
      //---------------------------------------------  
     }
      for (int i = 1 ; i <= 5 ; i++) {
       digitalWrite(step_Pin_2, HIGH);
       delay(20);
       digitalWrite(step_Pin_2, LOW);
       delay(20);
       //---------------------------------------------
        if (Bluetooth.read() == 'O') {
         while (Bluetooth.read() != 'N') {
         // do nothing
         // wait Bluetooth command 
         if (Bluetooth.read() == 'P') resetFunc();
         }   
        }
       //---------------------------------------------  
      }
     //********************************************************
     
     //Put Distance Zero position******************************
      digitalWrite(dir_Pin, LOW);
       while (!digitalRead(lsw_1)){
        digitalWrite(step_Pin, HIGH);
        delayMicroseconds(700);
        digitalWrite(step_Pin, LOW);
        delayMicroseconds(700);
        //---------------------------------------------
         if (Bluetooth.read() == 'O') {
          while (Bluetooth.read() != 'N') {
          // do nothing
          // wait Bluetooth command 
          if (Bluetooth.read() == 'P') resetFunc();
          }   
         }
        //---------------------------------------------      
       }
      //*******************************************************

      Bluetooth.println("Adjust Z-Axis Zero Distance Position");
       delay(50);
       while (dataInS != "I") {
         // do nothing
         // wait a command
         dataIn = Bluetooth.readStringUntil('\n');
         dataInS = dataIn.substring(0, 1);
         dataInN = dataIn.substring(1, dataIn.length());
         distance = dataInN.toInt();
         }
       dataIn = "";
       dataInS = "";
       dataInN = "";
        delay(50);

      while (lock) {
       dataIn = Bluetooth.readStringUntil('\n');
       dataInS = dataIn.substring(0, 1);
        if (dataInS == "I") lock = 1; //lock
        if (dataInS != "I") lock = 0;
      }
      
      if (!lock) {
       dataIn = "";
       dataInS = "";
       dataInN = "";
        delay(50);  
      if (Mode == 1 || Mode == 2 || Mode == 3) {  
       Bluetooth.println("Adjust Start Distance Setting");
       delay(50);
       while (dataInS != "I") {
         // do nothing
         // wait a command
         dataIn = Bluetooth.readStringUntil('\n');
         dataInS = dataIn.substring(0, 1);
         dataInN = dataIn.substring(1, dataIn.length());
         stoppedDis = dataInN.toInt();
       }
       dataIn = "";
       dataInS = "";
       dataInN = "";
        delay(50);

      if (Mode == 1 || Mode == 3) {
       Bluetooth.println("Adjust Distance Step");
       delay(50);
       while (dataInS != "J") {
         // do nothing
         // wait a command
         dataIn = Bluetooth.readStringUntil('\n');
         dataInS = dataIn.substring(0, 1);
         dataInN = dataIn.substring(1, dataIn.length());
         DisStep_BT = dataInN.toInt();
         DisStep = dataInN.toInt();
       }
       dataIn = "";
       dataInS = "";
       dataInN = "";
        delay(50);

        DisStep = DisStep*steps1mm;
      }
       
       Bluetooth.println("Adjust Initial Angle Setting");
       delay(50);
       while (dataInS != "K") {
         // do nothing
         // wait a command
         dataIn = Bluetooth.readStringUntil('\n');
         dataInS = dataIn.substring(0, 1);
         dataInN = dataIn.substring(1, dataIn.length());
         IniAngle = dataInN.toInt();
       }
       delay(50);
       
       if (IniAngle > 0 && IniAngle <= 25) digitalWrite(dir_Pin_2, LOW);
       if (IniAngle >= -25 && IniAngle <= 0) digitalWrite(dir_Pin_2, HIGH);
       delay(50);

       dataIn = "";
       dataInS = "";
       dataInN = "";
       delay(50); 

       if (Mode == 2 || Mode == 3) {
        Bluetooth.println("Adjust Angle Step");
        delay(50);
         while (dataInS != "L") {
          // do nothing
          // wait a command
          dataIn = Bluetooth.readStringUntil('\n');
          dataInS = dataIn.substring(0, 1);
          dataInN = dataIn.substring(1, dataIn.length());
          AngleStep = dataInN.toInt();
         }
       dataIn = "";
       dataInS = "";
       dataInN = "";
        delay(50); 

        Bluetooth.println("Adjust Final Angle Setting");
        delay(50);
         while (dataInS != "M") {
          // do nothing
          // wait a command
          dataIn = Bluetooth.readStringUntil('\n');
          dataInS = dataIn.substring(0, 1);
          dataInN = dataIn.substring(1, dataIn.length());
          FinAngle = dataInN.toInt();
         }
        dataIn = "";
        dataInS = "";
        dataInN = "";
        delay(50); 
        FinAngle = abs(IniAngle - FinAngle);
       }
             
      digitalWrite(dir_Pin, HIGH);
        while (distance < stoppedDis){
         for (int k = 1; k <= steps1mm; k++){
          digitalWrite(step_Pin, HIGH);
          delayMicroseconds(700);
          digitalWrite(step_Pin, LOW);
          delayMicroseconds(700);
          //----------------------------------------- 
           if (Bluetooth.read() == 'O') {
            while (Bluetooth.read() != 'N') {
            // do nothing
            // wait Bluetooth command 
            if (Bluetooth.read() == 'P') resetFunc();
            }   
           }
            if (digitalRead(lsw_2)) break;
          //-----------------------------------------
         }
         distance++;
        }  
       
       IniAngleABS = abs(IniAngle);
         
        for (int i = 1 ; i <= IniAngleABS ; i++) {
         digitalWrite(step_Pin_2, HIGH);
         delay(20);
         digitalWrite(step_Pin_2, LOW);
         delay(20);
         //----------------------------------------- 
          if (Bluetooth.read() == 'O') {
           while (Bluetooth.read() != 'N') {
           // do nothing
           // wait Bluetooth command 
           if (Bluetooth.read() == 'P') resetFunc();
           }   
          }
         //-----------------------------------------
        }
          
     Bluetooth.println("Starting...");
     delay(1500);
     Bluetooth.println("Z = " + String(stoppedDis) + "mm" + "    " + "Angle = " + String(IniAngle*1.8)+ "°");    
     delay(1500);
     digitalWrite(control, HIGH);
     delay(100);
     digitalWrite(control, LOW);
     delay(100); 
    }
    }
  }
        
  void loop() {
  
   if (Mode == 1 || Mode == 2 || Mode ==3) { 
     
   Bluetooth.println("Z = " + String(stoppedDis) + "mm" + "    " + "Angle = " + String(IniAngle*1.8) + "°");
   
   pinMode(control, INPUT);
   delay(1000); 
   
    do {
     //do nothing
     //wait a command
     if (Bluetooth.read() == 'P') resetFunc();
    } while (!digitalRead(control));
     
     delay(200);
     pinMode(control, OUTPUT);
     digitalWrite(control, LOW);
     
    //********____Mode 1____******************************
     if (Mode == 1){
      digitalWrite(dir_Pin, HIGH);       
      for (int k = 1; k <= DisStep; k++){
       digitalWrite(step_Pin, HIGH);
       delayMicroseconds(700);
       digitalWrite(step_Pin, LOW);
       delayMicroseconds(700);
       //----------------------------------------- 
        if (Bluetooth.read() == 'O') {
         while (Bluetooth.read() != 'N') {
          // do nothing
          // wait Bluetooth command 
          if (Bluetooth.read() == 'P') resetFunc();
         }   
        }
        if (digitalRead(lsw_2)) break;
       //-----------------------------------------
      }
      stoppedDis = stoppedDis + DisStep_BT;
       do { 
        // do nothing
        // wait a command
        if (Bluetooth.read() == 'P') resetFunc();
       } while (digitalRead(lsw_2));
     }
    //****************************************************
    //********____Mode 2____******************************
      if (Mode == 2){
        digitalWrite(dir_Pin_2, LOW);       
         for (int i = 1; i <= AngleStep; i++){
          digitalWrite(step_Pin_2, HIGH);
          delay(20);
          digitalWrite(step_Pin_2, LOW);
          delay(20);
          //----------------------------------------- 
           if (Bluetooth.read() == 'O') {
            while (Bluetooth.read() != 'N') {
             // do nothing
             // wait Bluetooth command 
             if (Bluetooth.read() == 'P') resetFunc();
            }   
           }
          //-----------------------------------------
         }
        AngleCounter = AngleCounter + AngleStep;
        IniAngle = IniAngle + AngleStep;
         do {
          // do nothing
          // wait a command
          if (Bluetooth.read() == 'P') resetFunc();
         } while (AngleCounter > FinAngle);
      } 
    //****************************************************
    //********____Mode 3____******************************
    if (Mode == 3) { 
     if (AngleCounter <= FinAngle) { 
      digitalWrite(dir_Pin_2, LOW);      
       for (int i = 1; i <= AngleStep; i++){
        digitalWrite(step_Pin_2, HIGH);
        delay(20);
        digitalWrite(step_Pin_2, LOW);
        delay(20);
        //----------------------------------------- 
         if (Bluetooth.read() == 'O') {
          while (Bluetooth.read() != 'N') {
          // do nothing
          // wait Bluetooth command 
           if (Bluetooth.read() == 'P') resetFunc();
          }   
         }
        //-----------------------------------------
       }
        AngleCounter = AngleCounter + AngleStep;
        IniAngle = IniAngle + AngleStep;
     }
      delay(500);
      if(AngleCounter > FinAngle) {
       IniAngle = IniAngle - AngleCounter;
        while (AngleCounter > 0 ) {
         digitalWrite(dir_Pin_2, HIGH);
         digitalWrite(step_Pin_2, HIGH);
         delay(20);
         digitalWrite(step_Pin_2, LOW);
         delay(20);
         //----------------------------------------- 
          if (Bluetooth.read() == 'O') {
           while (Bluetooth.read() != 'N') {
            // do nothing
            // wait Bluetooth command 
             if (Bluetooth.read() == 'P') resetFunc();
           }   
          }
          //-----------------------------------------
          AngleCounter--;
         }
        AngleCounter = 0;
       }
        if (AngleCounter == 0) {
         digitalWrite(dir_Pin, HIGH);       
          for (int k = 1; k <= DisStep; k++){
           digitalWrite(step_Pin, HIGH);
           delayMicroseconds(700);
           digitalWrite(step_Pin, LOW);
           delayMicroseconds(700);
           //----------------------------------------- 
            if (Bluetooth.read() == 'O') {
             while (Bluetooth.read() != 'N') {
              // do nothing
              // wait Bluetooth command 
               if (Bluetooth.read() == 'P') resetFunc();
             }   
            }
             if (digitalRead(lsw_2)) break;
           //-----------------------------------------
          }
          stoppedDis = stoppedDis + DisStep_BT;
           do { 
            // do nothing
            // wait a command
             if (Bluetooth.read() == 'P') resetFunc();
           } while (digitalRead(lsw_2));
        }   
    }
    //****************************************************
    
      digitalWrite(control, HIGH);
      delay(100);
      digitalWrite(control, LOW);
      delay(100);
   }
   
    if (Mode == 4) {

     if (Bluetooth.read() == 'P') resetFunc();
      
     dataIn = Bluetooth.readStringUntil('\n');
     dataInS = dataIn.substring(0, 1); 
          
     Bluetooth.println("Z = " + String(stoppedDis) + "mm" + "    " + "Angle = " + String(IniAngle*1.8)+ "°");

     if (dataInS == "W" && !digitalRead(lsw_2)) {
      for (int k = 1; k <= steps1mm; k++){
       digitalWrite(dir_Pin, HIGH);       
       digitalWrite(step_Pin, HIGH);
       delayMicroseconds(700);
       digitalWrite(step_Pin, LOW);
       delayMicroseconds(700);  
       dataIn = "";
       dataInS = "";
       if (digitalRead(lsw_2)) break;
      }
      stoppedDis++;
     }
     if (dataInS == "X" && !digitalRead(lsw_1)) {
      for (int k = 1; k <= steps1mm; k++){
       digitalWrite(dir_Pin, LOW);       
       digitalWrite(step_Pin, HIGH);
       delayMicroseconds(700);
       digitalWrite(step_Pin, LOW);
       delayMicroseconds(700);  
       dataIn = "";
       dataInS = "";
       if (digitalRead(lsw_1)) break;
      }
      stoppedDis--;
     }     
     if (dataInS == "Y" && IniAngle >= -30) {
       digitalWrite(dir_Pin_2, HIGH); 
       digitalWrite(step_Pin_2, HIGH);
       delay(20);
       digitalWrite(step_Pin_2, LOW);
       delay(20);
       dataIn = "";
       dataInS = "";
       IniAngle--;
     } 
     if (dataInS == "Z" && IniAngle <= 30) {
       digitalWrite(dir_Pin_2, LOW); 
       digitalWrite(step_Pin_2, HIGH);
       delay(20);
       digitalWrite(step_Pin_2, LOW);
       delay(20);
       dataIn = "";
       dataInS = "";
       IniAngle++;
     }
    }
  }
